<template>
  <a-layout>
    <a-layout-header>
      <span class="title">Tài khoản Tư vấn viên</span>
      <span style="flex: 1" />
      <div class="settings">
        <a-button
          @click="handleCreateConsultant"
          type="primary"
          icon="plus"
          style="margin-right: 8px;"
        >
          Thêm Tư vấn viên
        </a-button>
      </div>
    </a-layout-header>
    <a-layout-content>
      <search />
      <div style="height: 16px" />
      <a-card :bordered="false" :bodyStyle="{ padding: '24px 16px 8px 16px' }">
        <a-table
          :columns="columns"
          :row-key="record => record.id"
          :data-source="consultants"
          :pagination="pagination"
          :loading="loading"
          :scroll="{x:1270}"
          @change="onTableChange"
        >
          <template slot="userIdentity" slot-scope="userIdentity">
            <span>
              {{ userIdentity.gender | NamePrefix }}{{ userIdentity.name }}
            </span>
            <br>
            <span class="sub-text">{{ userIdentity.username }}</span>
          </template>
          <template slot="info" slot-scope="info">
            <span>
              <a-icon type="mail" />
              {{ info.email }}
            </span>
            <br>
            <span>
              <a-icon type="phone" />
              {{ info.telecom }}
            </span>
          </template>
          <template slot="status" slot-scope="status">
            <a-tag :color="status === 'ACTIVE' ? '#1890ff' : '#F5222D'">
              {{ status | UserStatus }}
            </a-tag>
          </template>
          <template
            slot="lastUpdatedDate"
            slot-scope="lastUpdatedDate"
          >
            {{ lastUpdatedDate | DateFormat('DD/MM/YYYY hh:mm') }}
          </template>
          <template
            slot="createdDate"
            slot-scope="createdDate"
          >
            {{ createdDate | DateFormat('DD/MM/YYYY hh:mm') }}
          </template>
          <template slot="action" slot-scope="supervisor">
            <a-dropdown :trigger="['click']">
              <a @click="e => e.preventDefault()" class="ant-dropdown-link">
                Công cụ
                <a-icon type="down" />
              </a>
              <a-menu slot="overlay">
                <a-menu-item key="0">
                  <a @click="e => handleUpdateConsultant(e, supervisor)">
                    <a-icon type="edit" />
                    <span class="menu-item">Chỉnh sửa thông tin tài khoản</span>
                  </a>
                </a-menu-item>
                <a-menu-item key="1">
                  <a-popconfirm
                    @confirm="handleUpdateConsultantStt(supervisor)"
                    :title="supervisor.status === 'ACTIVE' ? 'Bạn thực sự muốn vô hiệu tài khoản này ?' : 'Bạn thực sự muốn kích hoạt tài khoản này ?'"
                    ok-text="Có"
                    cancel-text="Không"
                  >
                    <a>
                      <a-icon :type="supervisor.status === 'ACTIVE' ? 'exclamation' : 'check'" />
                      <span class="menu-item">
                        {{ supervisor.status === 'ACTIVE' ? 'Vô hiệu tài khoản' : 'Tái kích hoạt tài khoản' }}
                      </span>
                    </a>
                  </a-popconfirm>
                </a-menu-item>
              </a-menu>
            </a-dropdown>
          </template>
        </a-table>
      </a-card>
    </a-layout-content>
  </a-layout>
</template>

<script>
import { mapActions, mapGetters } from 'vuex'
import { Search } from './components'
import { ehrApi } from '@/api'

export default {
  components: {
    Search
  },
  computed: {
    ...mapGetters('consultant', ['consultants', 'loading', 'page', 'total']),
    ...mapGetters('auth', ['userId', 'role']),
    columns () {
      return [
        {
          title: 'Định danh',
          key: 'name',
          sorter: true,
          width: 300,
          sortDirections: ['descend', 'ascend'],
          scopedSlots: { customRender: 'userIdentity' }
        },
        {
          title: 'Thông tin liên lạc',
          key: 'userInfo',
          scopedSlots: { customRender: 'info' },
          width: 300
        },
        {
          title: 'Trạng thái',
          dataIndex: 'status',
          key: 'status',
          width: 150,
          scopedSlots: { customRender: 'status' }
        },
        {
          title: 'Ngày tạo',
          dataIndex: 'createdDate',
          key: 'createdDate',
          width: 200,
          sorter: true,
          sortDirections: ['descend', 'ascend'],
          scopedSlots: { customRender: 'createdDate' }
        },
        {
          title: 'Chỉnh sửa gần đây',
          dataIndex: 'lastUpdatedDate',
          key: 'lastUpdatedDate',
          width: 200,
          sorter: true,
          sortDirections: ['descend', 'ascend'],
          defaultSortOrder: 'descend',
          scopedSlots: { customRender: 'lastUpdatedDate' }
        },
        {
          title: '',
          dataIndex: '',
          key: 'action',
          width: 120,
          fixed: 'right',
          scopedSlots: { customRender: 'action' }
        }
      ]
    },
    pagination () {
      return {
        current: this.page,
        pageSize: 10,
        total: this.total
      }
    },
    currentPage () {
      const { page } = this.$route.query
      const pageInt = parseInt(page)
      const currentPage = {
        page: 1,
        ...(pageInt > 1 && { page })
      }
      return currentPage
    },
    sorter () {
      const { sortField, sortOrder } = this.$route.query
      return {
        order: 'lastUpdatedDate DESC',
        ...(sortField && sortOrder && { order: `${sortField} ${sortOrder}` })
      }
    },
    getSortOrder (field) {
      const { sortField, sortOrder } = this.$route.query
      if (field === sortField) {
        if (sortOrder === 'ASC') { return 'ascend' }
        if (sortOrder === 'DESC') { return 'descend' }
      }
      return null
    },
    filter () {
      const { name, email, status } = this.$route.query
      const filter = {
        where: {
          ...(name && { name: { ilike: encodeURI(`%${name}%`) } }),
          ...(email && { email: { ilike: encodeURI(`%${email}%`) } }),
          ...(status && { status })
        },
        ...this.sorter,
        limit: 10
      }
      return filter
    }
  },
  watch: {
    '$route.query': {
      handler () {
        this.fetchConsultants()
      },
      immediate: true
    }
  },
  async created () {
    await this.fetchConsultants()
  },
  methods: {
    ...mapActions('consultant', ['getConsultants', 'updateConsultant']),
    fetchConsultants () {
      const payload = {
        filter: this.filter,
        ...this.currentPage,
        role: this.role
      }
      return this.getConsultants(payload)
    },
    async handleUpdateConsultantStt (data) {
      try {
        const { id, status } = data
        const payload = {
          id,
          status: status === 'ACTIVE' ? 'INACTIVE' : 'ACTIVE'
        }
        const usr = await ehrApi.admin.updateConsultantStt(payload)
        await this.updateConsultant(usr)
      } catch (error) {
        this.notiError(error)
      }
    },
    handleUpdateConsultant (e, data) {
      e.preventDefault()
      this.$router.push({ name: 'update-consultant', params: { id: data.id } })
    },
    handleCreateConsultant () {
      this.$router.push({ name: 'create-consultant' })
    },
    onTableChange (pagination, filters, sorter) {
      const queryParams = {
        page: pagination.current
      }
      const { columnKey: sortField, order: sortOrder } = sorter
      if (sortField && sortOrder) {
        queryParams.sortField = sortField
        queryParams.sortOrder = sortOrder === 'ascend' ? 'ASC' : 'DESC'
      }
      const { path } = this.$route
      this.$router.push({ path, query: { ...this.$route.query, ...queryParams } })
    },
    reload () {
      this.fetchConsultants()
    },
    notiError (err) {
      this.$notification.error({
        message: 'Lỗi hệ thống',
        description: 'Có lỗi xảy ra' || err,
        duration: 4
      })
    }
  }
}
</script>

<style lang="scss" scoped>
.menu-item {
  display: inline-block;
  padding-left: 8px;
}
.instant-code {
  display: flex;
  justify-content: center;
  align-items: center;
  font-size: 28px;
}
.sub-text {
  color: rgba(0, 0, 0, 0.4);
}
</style>
